<?php
/*
=== TODO ===
v1 upload & display pictures as slideshow
v1.1 mail notification
v1.2 have a mobile menu, that allows switching between different views (slideshow, thumbnail-per-month)
v2 comment-form and like-button to comment and rate a picture
*/

// load & init stuff
require_once("config.php");
require("mail.php");

// signal if upload success (1)
$uploadOk = 0;

// pictures will be sorted by YYYY-MM uploaded
$date = new DateTime();
$date_dir = date("Y-m"); // "2021-02"
$target_dir = "images/".$date_dir."/";

// if $target_dir does not exist
if(!is_dir($target_dir))
{
    // create it
    mkdir($target_dir, 0755);
}

// if a file was selected
if(array_key_exists("fileToUpload",$_FILES))
{
    $upload_filename = basename($_FILES["fileToUpload"]["name"]);
    $target_file = $target_dir . $upload_filename;

    // process the file to upload
    $uploadOk = 1;
    $imageFileType = strtolower(pathinfo($target_file,PATHINFO_EXTENSION));
    
    // Check if image file is a actual image or fake image
    if(isset($_POST["submit"])) {
      $check = getimagesize($_FILES["fileToUpload"]["tmp_name"]);
      if($check !== false) {
        echo "File is an image - " . $check["mime"] . ".";
        $uploadOk = 1;
      } else {
        echo "File is not an image.";
        $uploadOk = 0;
      }
    }
    
    // Check if file already exists
    if (file_exists($target_file)) {
      echo "Sorry, datei existiert bereits.";
      $uploadOk = 0;
    }
    
    // Check file size
    /*
    if ($_FILES["fileToUpload"]["size"] > 500000) {
      echo "Sorry, your file is too large.";
      $uploadOk = 0;
    }
    */
    
    // Allow certain file formats
    if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg" && $imageFileType != "gif" )
    {
        echo "Sorry, es sind nur die Formate JPG, JPEG, PNG & GIF erlaubt.";
        $uploadOk = 0;
    }

    // Check if $uploadOk is set to 0 by an error
    if ($uploadOk == 0)
    {
        echo "Sorry, beim Upload trat ein Fehler auf.";
    }
    else
    {
      // if everything is ok, try to upload file
      if (move_uploaded_file($_FILES["fileToUpload"]["tmp_name"], $target_file))
      {
        echo htmlspecialchars( basename( $_FILES["fileToUpload"]["name"])). " upload erfolgreich! :)";
        $MailText = '

        Hallo,
        <br>
        ein neues Bild wurde auf FamilyPicShare.de hochgeladen.
        <br>
        Direkter Link zum neuen Bild: <a href="https://FamilyPicShare.de/'.$target_file.'">https://FamilyPicShare.de/'.$target_file.'</a>
        <br>
        Over and Out! :)
        ';

        echo sendMail($from, $to, $MailText,"FamilyPicShare.de - ein neues Bild wurde hochgeladen :)");
      }
      else
      {
        echo "Sorry, beim Upload trat ein Fehler auf.";
      }
    }
}

// return all files and folders of the given dir (in relative format)
function listFiles($dir, &$results = array())
{
    $files = scandir($dir);
    foreach ($files as $key => $value)
    {
        // $path = realpath($dir . DIRECTORY_SEPARATOR . $value); // absolute path
        $absolute_path = realpath($dir . DIRECTORY_SEPARATOR . $value); // construct $absolute_path
        if (is_file($absolute_path))
        {
            if($value != "." && $value != "..")
            {
                $results[] = $value;
            }
        }
    }
    
    return $results;
}

// return all folders inside a folder (in relative format, ignore . and ..)
function listFolders($dir, &$results = array())
{
    $files = scandir($dir);
    foreach ($files as $key => $value)
    {
        $absolute_path = realpath($dir . DIRECTORY_SEPARATOR . $value); // construct $absolute_path
        if (is_dir($absolute_path))
        {
            if($value != "." && $value != "..")
            {
                $results[] = $value;
            }
        }
    }

    return $results;
}

// return all files and folders of the given dir (in relative format)
function listFilesAndFolders($dir, &$results = array())
{
    $files = scandir($dir);
    foreach ($files as $key => $value)
    {
        $absolute_path = realpath($dir . DIRECTORY_SEPARATOR . $value); // construct $absolute_path
        if (is_dir($absolute_path))
        {
            $results[] = $path;
        }
        else if ($value != "." && $value != "..")
        {
            getDirContents($path, $results);
            $results[] = $value;
        }
    }
    
    return $results;
}
?> 
<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<meta name="description" content="an secure (install .htaccess!!!) independent, self hosting easy to install web based software (no database needed) for easy sharing pictures with family (uploading, categorizing, finding pictures)"/>
		<meta name="keywords" content="share,pictures,family" />
		<title>share family pictures with privacy & secure & easy</title>
		<!-- external styles -->
		<link href="css/style.css" type="text/css" rel="stylesheet"/>
		<script type="text/javascript" src="js/placeholders.min.js"></script>
		<script src="js/jquery.v1.11.1.min.js"></script>
		<script src="js/jquery.cycle2.js"></script
	</head>
	<body id="body">
		<div id="parent">
			<div class="centered">
				<div id="headline" class="boxShadows">
					<h1>
                        share family pictures
					</h1>
                    <h3>
                        with privacy & secure & easy
                    </h3>
					<div id="PictureUploadForm">
                        <form action="index.php" method="post" enctype="multipart/form-data">
                          Auswählen:
                          <input type="file" name="fileToUpload" id="fileToUpload">
                          <input type="submit" value="hochladen" name="submit">
                        </form>
					</div>
				</div>

                    <button data-cycle-cmd="prev">Prev</button>
                    <button data-cycle-cmd="next">Next</button>

				<div id="content">
                    <div id="main">
                        <div class="cycle-slideshow" data-cycle-fx="scrollHorz" data-cycle-timeout="5000" data-cycle-swipe="true" data-cycle-swipe-fx="scrollHorz" style="overflow: hidden;">

                            <div class="cycle-caption"></div>
                            <?php
                            // iterate over folder images
                            $array_of_dirs = listFolders("./images");

                            foreach($array_of_dirs as $dir)
                            {
                                $array_of_files = listFiles("./images/".$dir);
                                foreach ($array_of_files as $file)
                                {
                                    echo '<img src="'."./images/".$dir."/".$file.'">';
                                }
                            } 
                            ?>
                        </div>
                    </div>
				</div>
			</div>
		</div>
	</body>
</html>
